config/routes.rb
Rails.application.routes.draw do
  resources :leaderboards
  devise_for :users
  resources :lessons
  resources :questions
  resources :quizzes
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  # post 'submit_quiz', to: 'take_quiz#submit'
  post 'take_quiz/:quiz_id/submit', to: 'take_quiz#submit', as: :submit_quiz

  resources :quizzes do
    resources :questions
  end

  resources :lessons do
    resources :comments, only: [:create]
  end

  resources :leaderboards, only: [:index]
  
  resources :take_quiz, only: [:index, :show]
  # Defines the root path route ("/")
  # root "posts#index"
  root to: "lessons#index"
end

app/models/leaderboard.rb
class Leaderboard < ApplicationRecord
  belongs_to :user
end

app/controllers/leaderboards_controller.rb
class LeaderboardsController < ApplicationController
  before_action :set_leaderboard, only: %i[ show edit update destroy ]

  # GET /leaderboards or /leaderboards.json
  def index
    @leaderboard_data = QuizAttempt
      .select('user_id, MAX(score) as max_score')
      .group(:user_id)
      .order('max_score DESC')
      .map { |attempt| [User.find(attempt.user_id).email, attempt.max_score] }
  end

  # GET /leaderboards/1 or /leaderboards/1.json
  def show
  end

  # GET /leaderboards/new
  def new
    @leaderboard = Leaderboard.new
  end

  # GET /leaderboards/1/edit
  def edit
  end

  # POST /leaderboards or /leaderboards.json
  def create
    @leaderboard = Leaderboard.new(leaderboard_params)

    respond_to do |format|
      if @leaderboard.save
        format.html { redirect_to leaderboard_url(@leaderboard), notice: "Leaderboard was successfully created." }
        format.json { render :show, status: :created, location: @leaderboard }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @leaderboard.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /leaderboards/1 or /leaderboards/1.json
  def update
    respond_to do |format|
      if @leaderboard.update(leaderboard_params)
        format.html { redirect_to leaderboard_url(@leaderboard), notice: "Leaderboard was successfully updated." }
        format.json { render :show, status: :ok, location: @leaderboard }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @leaderboard.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /leaderboards/1 or /leaderboards/1.json
  def destroy
    @leaderboard.destroy!

    respond_to do |format|
      format.html { redirect_to leaderboards_url, notice: "Leaderboard was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_leaderboard
      @leaderboard = Leaderboard.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def leaderboard_params
      params.require(:leaderboard).permit(:user_id, :score)
    end
end

app/helpers/leaderboards_helper.rb
module LeaderboardsHelper
end

app/views/leaderboards/_form.html.erb
<%= form_with(model: leaderboard) do |form| %>
  <% if leaderboard.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(leaderboard.errors.count, "error") %> prohibited this leaderboard from being saved:</h2>

      <ul>
        <% leaderboard.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :user_id, style: "display: block" %>
    <%= form.text_field :user_id %>
  </div>

  <div>
    <%= form.label :score, style: "display: block" %>
    <%= form.number_field :score %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/leaderboards/_leaderboard.html.erb
<div id="<%= dom_id leaderboard %>">
  <p>
    <strong>User:</strong>
    <%= leaderboard.user_id %>
  </p>

  <p>
    <strong>Score:</strong>
    <%= leaderboard.score %>
  </p>

</div>

app/views/leaderboards/edit.html.erb
<h1>Editing leaderboard</h1>

<%= render "form", leaderboard: @leaderboard %>

<br>

<div>
  <%= link_to "Show this leaderboard", @leaderboard %> |
  <%= link_to "Back to leaderboards", leaderboards_path %>
</div>

app/views/leaderboards/index.html.erb
<div class="container mt-4">
  <div class="row">
    <div class="col-md-8 offset-md-2">
      <h1 class="mb-4">Leaderboard</h1>
      
      <div class="list-group w-auto">
        <% @leaderboard_data.each_with_index do |(user_email, score), index| %>
          <a href="#" class="list-group-item list-group-item-action d-flex gap-3 py-3" aria-current="true">
            <i class="fas fa-user-circle fa-2x"></i>
            <div class="d-flex gap-2 w-100 justify-content-between">
              <div>
                <h6 class="mb-0">
                  <%= user_email %>
                  <% if index == 0 %>
                    <i class="fas fa-medal text-gold" style="color: gold;"></i> <!-- Gold medal for the top user -->
                  <% elsif index == 1 %>
                    <i class="fas fa-medal text-silver" style="color: silver;"></i> <!-- Silver medal for the second user -->
                  <% elsif index == 2 %>
                    <i class="fas fa-medal text-bronze" style="color: #cd7f32;"></i> <!-- Bronze medal for the third user -->
                  <% end %>
                </h6>
              </div>
              <small class="opacity-50 text-nowrap"><p class="mb-0 opacity-75"><%= score %> points</p></small>
            </div>
          </a>
        <% end %>
      </div>

      <!-- Add a link to the new leaderboard if needed -->
      <!-- <%= link_to "New leaderboard", new_leaderboard_path, class: "btn btn-primary" % -->
    </div>
  </div>
</div>

app/views/leaderboards/new.html.erb
<h1>New leaderboard</h1>

<%= render "form", leaderboard: @leaderboard %>

<br>

<div>
  <%= link_to "Back to leaderboards", leaderboards_path %>
</div>

app/views/leaderboards/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @leaderboard %>

<div>
  <%= link_to "Edit this leaderboard", edit_leaderboard_path(@leaderboard) %> |
  <%= link_to "Back to leaderboards", leaderboards_path %>

  <%= button_to "Destroy this leaderboard", @leaderboard, method: :delete %>
</div>